/*

   Copyright (C) 2006 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

### File Specific:
   main-programmer:
*/

#include "blink.h"

#include "util/loading/load_param.h"
#include "util/loading/factory.h"
#include "debug.h"
#include "state.h"
#include "effects/billboard.h"

#include "material.h"






ObjectListDefinition(Blink);
CREATE_FACTORY(Blink);

/**
 * standart constructor
 */
Blink::Blink (const TiXmlElement* root)
{
  this->init();

  if( root)
    this->loadParams(root);

//   this->bBoard->setSize(this->size, this->size);
}


/**
 * destroys a Blink
 */
Blink::~Blink ()
{
//  if (this->material)
  //  delete this->material;
}


/**
 * initializes the Blink
 */
void Blink::init()
{
  this->registerObject(this, Blink::_objectList);
  this->setName("Blink");

  this->toList(OM_COMMON);

  this->bBoard = new Billboard;
  this->bBoard->setVisibiliy(true);
  this->bBoard->setTexture("maps/star_alpha.png");
  this->bBoard->setAbsCoor(this->position.x, this->position.y, this->position.z);


  /// Standard values
  this->setAbsCoor(0, 0, 0); 
  this->position = Vector(0, 0, 0); ///remove
  this->color = Color(1, 0, 0);
  this->size = 10;
  this->omega = 10;
  this->angle = rand() % 1000;
  PRINTF(0)("\n\n\n\n\n\n\nangle: %f\n\n\n\n\n\n\n\n", this->angle);
  this->angle *= 2 * M_PI;
  PRINTF(0)("\n\n\n\n\n\n\nangle: %f\n\n\n\n\n\n\n\n", this->angle);
}


/**
 *  load params
 * @param root TiXmlElement object
 */
void Blink::loadParams(const TiXmlElement* root)
{
  WorldEntity::loadParams(root);

  LoadParam(root, "position", this, Blink, setPosition);
  LoadParam(root, "size", this, Blink, setSize);
  LoadParam(root, "color", this, Blink, setColor);
  LoadParam(root, "omega", this, Blink, setOmega);
}


/**
 * ticks the Blink
 * @param dt the time to ticks
 */
void Blink::tick(float dt)
{
  this->angle += dt * this->omega;

  if (this->angle > 2 * M_PI)
    this->angle -= 2 * M_PI;

  this->blinkStr = sinf(angle);

  this->bBoard->colorTexture(Color(color.r(), color.g(), color.b(), 1));
}


/**
 * draws the blink
 */
void Blink::draw() const
{

}
